Subject: [PSAMP] Review: draft-ietf-psamp-info-07

From: Sven Anderson <[email-masked]>
Date: Tue, 04 Dec 2007 17:17:23 +0100

Hi,

here are my few comments on draft-ietf-psamp-info-07. (I hope not too
late?) As I'm not reading the PSAMP mailing lists, I'm not aware of what
might have been discussed already. So ignore accordingly.

Cheers,

Sven

> Internet-Draft           PSAMP Information Model            October 2007
> 
> 
> 1.  Introduction
> 
>    Packet sampling techniques are required for various measurement
>    scenarios.  The packet sampling (PSAMP) protocol provides mechanisms

"Packet Sampling" is uppercase in the abstract. In general there are
both "sampling" and "Sampling" in the document. Same is true for
"Filtering".

>    for packet selection using different filtering and sampling
>    techniques.  A standard way for the export and storage is required.
>    The definition of the PSAMP information and data model is based on
>    the IP Flow Information eXport (IPFIX) protocol
>    [I-D.ietf-ipfix-protocol].  The PSAMP protocol document
>    [I-D.ietf-psamp-protocol] specifies how to use the IPFIX protocol in
>    the PSAMP context.
> 
>    This document examines the IPFIX information model
>    [I-D.ietf-ipfix-info] and extends it to meet the PSAMP requirements.
>    Therefore, the structure of this document is strongly based on the
>    IPFIX document.  It complements the PSAMP protocol specification by
>    providing an appropriate PSAMP information model.  The main part of
>    this document, section 8, defines the list of Information Elements to
>    be transmitted by the PSAMP protocol.  Sections 6 and 5 describe the

6 and 5, not 5 and 6?

>    data types and Information Element properties used within this
>    document and their relationship to the IPFIX information model.
> 
>    The main body of section 8 was generated from a XML document.  The
>    XML-based specification of the PSAMP Information Elements can be used
>    for automatically checking syntactical correctness of the
>    specification.  Furthermore it can be used - in combination with the
>    IPFIX information model - for automated code generation.  The
>    resulting code can be used in PSAMP protocol implementations to deal
>    with processing PSAMP information elements.
> 
>    For that reason, the XML document that served as source for section 8
>    is attached to this document in Appendix A.
> 
>    Note that although partially generated from the attached XML
>    documents, the main body of this document is normative while the
>    appendices are informational.
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> Dietz, et al.         draft-ietf-psamp-info-07.txt              [Page 5]

[...]

> Internet-Draft           PSAMP Information Model            October 2007
> 
> 
> 8.  The PSAMP Information Elements
> 
>    This section describes the Information Elements used by the PSAMP
>    protocol.
> 
>    Each Information Element specified in section 8.2 below is allocated
>    a unique identifier in accordance with section 5 of the IPFIX
>    information model [I-D.ietf-ipfix-info].  The assignments are
>    controlled by IANA as an extension of the IPFIX Information Model.

Is this correct English? Isn't it more like "For each Information
Element specified in section 8.2 below a unique identifier is allocated
in accordance with section 5 of the IPFIX information model."

>    The Information Elements specified by the IPFIX information model
>    [I-D.ietf-ipfix-info] are used by the PSAMP protocol where
>    applicable.  To avoid inconsistencies between the IPFIX and the PSAMP
>    information and data models, only those Information Elements that are
>    not already described by the IPFIX information model are defined
>    here.
> 
> 8.1.  PSAMP Usage of IPFIX Attributes
> 
>    This section lists additional Information Elements that are needed in
>    the PSAMP context and introduces their usage.
> 
>    List of additional PSAMP Information Elements:
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> Dietz, et al.         draft-ietf-psamp-info-07.txt             [Page 17]

[...]

> Internet-Draft           PSAMP Information Model            October 2007
> 
> 
>       2 Systematic time-based Sampling
> 
>       3 Random n-out-of-N Sampling
> 
>       4 Uniform probabilistic Sampling
> 
>       5 Property match Filtering
> 
>       6 Hash based Filtering using BOB
> 
>       7 Hash based Filtering using IPSX
> 
>       8 Hash based Filtering using CRC

So a simple pattern match (instead of a hash) is 5 as well?

> 
>       The parameters for most of these algorithms are defined in this
>       information model.  Some parameters for these algorithms are not
>       covered by this information model since they very much depend on
>       the underlying hardware.
> 
>       This list will be maintained by IANA.  IANA can update this
>       Information Element as long as there's a new RFC specifying the
>       algorithm and any new Information Elements which are required.

"as long as there's _no_ new RFC..."
or
"until there's a new RFC..."

Right?

> 
>    Abstract Data Type:  unsigned16
> 
>    Data Type Semantics:  identifier
> 
>    ElementId:  304
> 
>    Status:  current
> 
> 8.2.5.  samplingPacketInterval
> 
>    Description:
> 
>       This Information Element specifies the number of packets that are
>       consecutively sampled.  For example a value of 100 means that 100
>       contiguous packets are sampled.
> 
>       For example, this Information Element may be used to describe the
>       configuration of a systematic count-based sampling Selector.

I think this name will lead to misunderstandings. Although
mathematically correct, the term "interval" is too general and is also
used for a time space or other kind of spaces. So I'm sure many people
will assume that this is the packet based sampling rate, without reading
this document. I would suggest something like:

samplingPacketQuantity
samplingPacketExtent
samplingPacketAmount
samplingPacketRange

> 
>    Abstract Data Type:  unsigned32
> 
>    ElementId:  305
> 
> 
> 
> 
> 
> 
> Dietz, et al.         draft-ietf-psamp-info-07.txt             [Page 20]
> 
> Internet-Draft           PSAMP Information Model            October 2007
> 
> 
>    Status:  current
> 
>    Units:  packets
> 
> 8.2.6.  samplingPacketSpace
> 
>    Description:
> 
>       This Information Element specifies the number of packets between
>       two "samplingPacketInterval"s.  A value of 100 means that the next
>       interval starts after 100 packets (which are not sampled) when the
>       current "samplingPacketInterval" is over.
> 
>       For example, this Information Element may be used to describe the
>       configuration of a systematic count-based sampling Selector.
> 
>    Abstract Data Type:  unsigned32
> 
>    ElementId:  306
> 
>    Status:  current
> 
>    Units:  packets
> 
> 8.2.7.  samplingTimeInterval
> 
>    Description:
> 
>       This Information Element specifies the time interval in
>       microseconds during which all arriving packets are sampled.
> 
>       For example, this Information Element may be used to describe the
>       configuration of a systematic time-based sampling Selector.
> 

Same as for samplingPacketInterval. I think samplingTimeRange or
samplingTimeExtent is better.

>    Abstract Data Type:  dateTimeMicroseconds
> 
>    ElementId:  307
> 
>    Status:  current
> 
>    Units:  microseconds
> 
> 8.2.8.  samplingTimeSpace
> 
> 
> 
> 
> 
> 
> 
> 
> Dietz, et al.         draft-ietf-psamp-info-07.txt             [Page 21]

[...]

> Internet-Draft           PSAMP Information Model            October 2007
> 
> 
> 10.  IANA Considerations
> 
>    This document specifies an initial set of PSAMP Information Elements
>    as specified in [I-D.ietf-psamp-sample-tech], as an extension to the
>    IPFIX Information Elements [I-D.ietf-ipfix-info].  New assignments
>    for PSAMP Information Elements will be administered according to
>    rules explained in the "IANA Consideration" section of the IPFIX
>    Information Model document [I-D.ietf-ipfix-info].
> 
>    Note that the PSAMP Information Element IDs were initially started at
>    the value 301, in order to leave a gap for any ongoing IPFIX work
>    requiring new Information Elements.  It is expected that this gap in
>    the Information Element numbering will be filled in by IANA with new
>    IPFIX Information Elements.

Shouldn't it be explicitly stated, that PSAMP shares the same IE number
space with IPFIX? In theory it is also possible to heritage all the
definitions, but have separate number spaces.

> 
>    Appendix B defines an XML schema which may be used to create
>    consistent machine readable extensions to the IPFIX information
>    model.  This schema introduces a new namespace, which will be
>    assigned by IANA according to [RFC3688].
> 
>    The selectorAlgorithm registry is maintained by IANA and can be
>    updated as long as specifications of the new method(s) and any new
>    Information Elements are provided.
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> 
> Dietz, et al.         draft-ietf-psamp-info-07.txt             [Page 34]

_______________________________________________
PSAMP mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/psamp